//
// <PW-Id>
//

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
// Copyright 2018-2020 by Pierre Wolfers Meylan France                       //
//                                                                           //
// This library is free software. Distribution and use rights are outlined   //
// in the file "COPYING" which should have been included with this file.     //
// If this file is missing or damaged, see the license at:                   //
//                                                                           //
//    <To be define when ready>                                              //
//                                                                           //
//   This license described in this file overrides all other licenses that   //
//   might be specified in other files for this library.                     //
//                                                                           //
//   This library is free software; you can redistribute it  and/or modify   //
//   it under the terms of the GNU Lesser General Public License as publi-   //
//   shed by  the  Free Software  Foundation;  either  version 2.1  of the   //
//   License, or (at your option) any later version.                         //
//                                                                           //
//   This library  is  distributed in  the  hope that  it will  be useful,   //
//   but   WITHOUT  ANY  WARRANTY;  without even  the  implied warranty of   //
//   MERCHANTABILITY  or  FITNESS  FOR A  PARTICULAR PURPOSE.  See the GNU   //
//   Library General Public License for more details.                        //
//                                                                           //
//   You should have  received  a copy of  the  GNU Lesser General  Public   //
//   License  along with this library  (see COPYING.LIB); if not, write to   //
//   the Free Software Foundation :                                          //
//                        Inc., 675 Mass Ave, Cambridge, MA 02139, USA.      //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////



//
// P.Wolfers DiaViewer Software
//


//
// Module to give easy FLTK table for display.
//
//


#include "Table_Display.h"



void DsplTable::EventCallback( Fl_Widget * w, void * data ) {
  DsplTable * o = (DsplTable*)data;
  o->EventCallback2();
} // DsplTable::EventCallback( Fl_Widget * w, void * data ).



void DsplTable::EventCallback2() {
  int R = callback_row(), C = callback_col();
  TableContext ntx = callback_context();
  UserTableCallback( cntx, R, C );
} // DsplTable::EventCallback2().



DsplTable::DsplTable( int x, int y, int w, int h, char *l ) : public Fl_Table( x, y, w, h, l )
{
  cell_bgcolor = FL_WHITE, cell_fgcolor = FL_BLACK;
  callback( &EventCallback, (void*)this );
  end();
} // DsplTable::DsplTable( int x, int y, int w, int h, char *l ).




//
// end of <PW-Id>.
//
