
//
// P.Wolfers DiaViewer Software
//

#include <unistd.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>

#include <errno.h>
#include <stdio.h>
#include <string.h>
#include <math.h>


//#include "src/DiViewer_SRV.h"


//static FilePath Ptrg( 16 );


static int TreeDirCreate( const char * path )
{
    char            * sbpath;
    int ier =     0,      ij,
        len = strlen( path );
    
    if (ier = access( path, F_OK|R_OK|W_OK )) {
        if (errno==ENOENT){ // When the directory does exist or with some access error.
            ij = len - 1;
            if (path[ij]=='/') ij--; // Skip possible final '/'.
            // We extract the parent path of the top directory.
            while ((ij>0)&&(path[ij]!=':')&&(path[ij]!='/')) ij--;
            if (!ij)
                sbpath = strdup( "./" );
            else {
                if (path[ij]==':') return -1;
                sbpath = new char[ij+1];
                for(int i=0;i<=ij;i++) sbpath[i] = path[i];
                sbpath[ij+1] = 0;
            }
            // We try to get access of this parent path.
            ier = TreeDirCreate( sbpath );
            if (!ier) { // The parent path is existing.
                ier = mkdir( path, S_IRWXU ); // Create the directory. 0 for default protection ?.
            }
        }
    }
    return ier;
}



static int FileCreate( const char * path, const char * name )
{
    char     * fullpath = NULL;
    int   pln = strlen( path ),
          fln = strlen( name ),
                           ier;
    FILE                  * fp;

    if (ier = TreeDirCreate( path )) {
        printf( " Error : Cannot use the path \"%s\"\n\t%s\n", path, strerror( errno ) );
    } else {
        fullpath = new char[pln+fln+1];
        sprintf( fullpath, "%s%s", path, name );
        if (ier = access( fullpath, F_OK )) {
            if (fp = fopen( fullpath, "w" )) {
                fprintf( fp, " je suis le fichier %s\n", name );
                fclose( fp );
                printf( " File \"%s\" is created.\n", fullpath );
            } else {
                printf( " error: Cannot creat the file \"%s\"\n\t%s\n", fullpath, strerror( errno ) );
                ier = -1;
            }
        } else printf( " File \"%s\" is already existing.\n", fullpath );
    }
    return ier;
} // int FileCreate( const char * path, const char * name ).



int main( int argc, char ** argv )
{
    int ier = 0;
    char fnm[64];

    for(int i=1;i<argc;i++) {
        snprintf( fnm, 63, "fichier_%02d", i );
        ier = FileCreate( argv[i], fnm );
    }
    return 0;
}

