static int SolveLogicalPath( const char * fsp, char * &path )
{
    typedef struct {
        const char * fnam;
        int          fsiz,
                     fpos;
    } pelm;

    const char   * trn,
                 * nfp,
                 *  fn;
    int        fs,  fp;
    int  idp, lnf, lll;
    int    skp =    -1;
    char            ch;
    bool   top =     0;
    const int MAXSTK=8;
    
    pelm      stack[8];

    if (fsp&&fsp[0]) {
        nfp = fsp;
        do {
            lnf = strlen( nfp );
            idp = 0;
            while ((idp<lnf)&&
                   (nfp[idp]!=DEV_SEPAR)&&
                   (nfp[idp]!=DIR_SEPAR)) idp++;
            if (nfp[idp]==DEV_SEPAR) {
                char *log = (char*)malloc( idp+1 );
                for(int i=0;i<idp;i++) {
                    ch = nfp[i];
                    if ((ch>='a')&&(ch<='z')) ch -= 'a'-'A';
                    log[i] = ch;
                }
                log[idp] = 0;
                trn = getenv( log );
                if (trn&&trn[0]) {
                    lll = strlen( trn );
                    if ((trn[lll]==DIR_SEPAR)||
                        (nfp[idp]==DIR_SEPAR)) {
                        idp++;
                        if ((trn[lll]==DIR_SEPAR)&&
                            (nfp[idp]==DIR_SEPAR)) idp++;
                        fn = nfp; fs = lnf; fp = idp;
                    } else {
                        fn = trn; fs = lll; fp = 0;
                        skp = -1; top = 1;
                    }
                } else { fn = nfp; fs = lnf; fp = 0; top = 1; }
 //               free( log );
            } else  { fn = nfp; fs = lnf; fp = 0; top = 1; }
            if (top) {
                skp++;
                if (skp>=MAXSTK) return -1;
                stack[skp].fnam = fn;
                stack[skp].fsiz = fs;
                stack[skp].fpos = fp;
            }
        } while (!top);

        // Now we can build the complete path.
        lnf = 0;
        for(int i=skp;i>=0;i--) lnf += fs - fp; // Compute the final size of the path.
        path = (char*)malloc( lnf+2 );
        lll = 0;
        while (skp>=0) {
            fp = stack[skp].fpos;
            fs = stack[skp].fsiz -fp;
            strcpy( path+lll, stack[skp].fnam+fp );
            lll += fs;
            skp--;
        }
    }
    return lnf;
} // SolveLogicalPath.


static void SetUpDefaultDir()
{
    const char DirDef[] = { '.', DIR_SEPAR, 0 };

    if (SetUpDir) free( SetUpDir );
    SetUpDir = (char*)malloc( 3 );
    strcpy( SetUpDir, DirDef );
} // SetUpDefaultDir.



