//
// <PW-Id>
//

///////////////////////////////////////////////////////////////////////////////
//                                                                           //
// Copyright 2018-2020 by Pierre Wolfers Meylan France                       //
//                                                                           //
// This library is free software. Distribution and use rights are outlined   //
// in the file "COPYING" which should have been included with this file.     //
// If this file is missing or damaged, see the license at:                   //
//                                                                           //
//    <To be define when ready>                                              //
//                                                                           //
//   This license described in this file overrides all other licenses that   //
//   might be specified in other files for this library.                     //
//                                                                           //
//   This library is free software; you can redistribute it  and/or modify   //
//   it under the terms of the GNU Lesser General Public License as publi-   //
//   shed by  the  Free Software  Foundation;  either  version 2.1  of the   //
//   License, or (at your option) any later version.                         //
//                                                                           //
//   This library  is  distributed in  the  hope that  it will  be useful,   //
//   but   WITHOUT  ANY  WARRANTY;  without even  the  implied warranty of   //
//   MERCHANTABILITY  or  FITNESS  FOR A  PARTICULAR PURPOSE.  See the GNU   //
//   Library General Public License for more details.                        //
//                                                                           //
//   You should have  received  a copy of  the  GNU Lesser General  Public   //
//   License  along with this library  (see COPYING.LIB); if not, write to   //
//   the Free Software Foundation :                                          //
//                        Inc., 675 Mass Ave, Cambridge, MA 02139, USA.      //
//                                                                           //
///////////////////////////////////////////////////////////////////////////////



//
// P.Wolfers DiaViewer Software
//

//
// Module to manage a slide collection
// DCM = DiaViewer Collection Management.
//

#ifndef DIAVIEWER_DCM
#define DIAVIEWER_DCM

#include "DiaViewer_SRV.h"
#include "DiaViewer_DIA.h"




// Define the increment(step) to allocate (or extend) a dynamic table of item.
#define TABLE_ALLOC_STEP     16
// Define the increment(step) to allocate (or extend) a character table.
#define STRING_ALLOC_STEP    64

// Define the limit table length to select the quick sort process.
#define QSORT_LIMIT           8

// Define the maximum length of future slide's filenames and (Chapter and Volume) directory names.
#define MAX_SLI_NAME_SIZE    31
#define MAX_CHA_NAME_SIZE    31
#define MAX_VOL_NAME_SIZE    31
// Define the maximum length of future head directory of the slide collection.
#define MAX_COL_NAME_SIZE    63

// Define the maximum string size for the sprinf formats.
#define MAX_FRM_SIZE         16




//
// External definitions
//

extern int         SlideNumber, // Current Slide number in its film.
                    FilmNumber, // Current film number.
                 ChapterNumber, // Current Chapter Number.
                  VolumeNumber; // Current Volume Number.

extern char  DiaNamFrm[MAX_FRM_SIZE+1], // sprintf Format for slide/Diapositive Future FileName.
             ChaNamFrm[MAX_FRM_SIZE+1], // sprintf Format for Chaper Directory Name.
             VolNamFrm[MAX_FRM_SIZE+1]; // sprintf Format for Volume Directory name.

extern char   * CollectionPath, // The future Collection Path (including the collection name).
              *    CollNamePtr, // Pointer of the collection name in CurrCollPath.
              *  CurSliComment, // The Comment of the current Slide.
              *  CurrSlidePath; // The File Path of the current Slide.

extern char    CurSliName[MAX_SLI_NAME_SIZE+1], // To store the current name of used Diapositive/Slide, ...
               CurChaName[MAX_CHA_NAME_SIZE+1], // Chapter, Volume Directories Names.
               CurVolName[MAX_VOL_NAME_SIZE+1]; // 
 


//
// Define the Global (Public) function.
//

// To Open all SetUp file specified Volume.
void OpenVolumeQuList();

// To create a Volume slides and set the slide to display.
int  OpenSlideVolume( const char * fpath );

// To close and free all volume allocations.
///void CloseSlideVolume( VolEntry * vol );


#endif

//
// end of <PW-Id>.
//
