
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <math.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>




//
// Routine/function to perform the ranking.
//

#define BUFSIZE 4096
#define UNIX_IO

int Unix = 0;


static int FileCopy( const char * dstpth, const char * srcpth )
// Copy one file.
// Used to copy the image files from the source volume to the target one.
// It is binary level copy.
{
    int           ierr = 0;
    size_t            size;
    char   buffer[BUFSIZE];

    if (!access( srcpth, F_OK )) {

if (Unix) {
        int       src, dst;
        struct stat stasrc;
        mode_t        mode;

        if ((src = open( srcpth, O_RDONLY )) == -1) {
            printf( "Cannot open the slide file \"%s\":\n\t%s\n", srcpth, strerror( errno ) );
            ierr = -1;            
        } else {
            fstat( src, &stasrc );
            
            if ((dst = open( dstpth, O_WRONLY|O_CREAT|O_TRUNC, stasrc.st_mode )) == -1) {
                printf( "Cannot create the slide file \"%s\":\n\t%s\n", dstpth, strerror( errno ) );
                ierr = -1;
            } else {
                while ((size = read( src, buffer, BUFSIZE )) > 0)
                    if (write( dst, buffer, size ) == -1) {
                        printf( "Write Error one slide file \"%s\":\n\t%s\n", srcpth, strerror( errno ) );
                        ierr = -1; break; 
                    }
                if (size == -1) {
                    printf( "Read Error one slide file \"%s\":\n\t%s\n", srcpth, strerror( errno ) );
                    ierr = -1;
                }
                close( dst );
            }
            close( src );
        }

} else {
        FILE  * src, * dst;

        if (src = fopen( srcpth, "rb" )) {
            if (dst = fopen( dstpth, "wb" )) {
                while ((size = fread( buffer, sizeof( char ), BUFSIZE, src )) > 0) {
                    if (fwrite( buffer, sizeof( char ), size, dst ) != size) {
                        printf( "IO Error one slide file \"%s\":\n\t%s\n", srcpth, strerror( errno ) );
                        ierr = -1; break;                        
                    }
                }
                fclose( dst );
            } else {
                printf( "Cannot create the slide file \"%s\":\n\t%s\n", dstpth, strerror( errno ) );
                ierr = -1;
            }
            fclose( src );
        } else {
            printf( "Cannot open the slide file \"%s\":\n\t%s\n", srcpth, strerror( errno ) );
            ierr = -1;
        }
}
    }
    return ierr;
} // static int FileCopy( const char * dst, const char * src ).



int main( int argc, char ** argv )
{
    if (argc < 2) {
        printf( "Command form:\n\t testcopy <source> <destination> [-unix]\n" );
        return 1;
    }

    if (argc>2) Unix = 1;

    return FileCopy( argv[1], argv[2] );

}

